︠96417993-9950-4422-84a0-bd541ca28da0s︠
def random_n_bit_prime(n):
    return random_prime(2^n-1,lbound=2^(n-1))
︡7c49a6f0-93f9-4b50-bfbc-eb1b4f0f79c9︡{"done":true}︡
︠4a76250f-e024-405d-8f57-aa7a9f98637c︠

︡05abcd7b-fa72-4064-bdac-9330e55f12d0︡
︠25b8351d-bcde-487c-bd51-eeeb3f11493as︠
def factor_time(bits):
    return timeit('factor(random_n_bit_prime('+bits.str()+')*random_n_bit_prime('+bits.str()+'))',seconds=True)
︡02cae72a-afa3-4105-a92e-dab54c4bd3b2︡{"done":true}︡
︠84385d47-97c1-4bb1-887f-b822599ab68ds︠
t=factor_time(65)
︡5a17d37c-6388-41e2-996c-0d61aaee8b9c︡{"stdout":"0.0906300067902"}︡{"stdout":"\n"}︡{"done":true}︡
︠5ed0c849-eb66-4f9d-b914-fd7983d3202es︠
random_n_bit_prime(90)
︡1cca0b5d-e349-4b21-aa94-6e365f7b2b88︡{"stdout":"648077196930950210966755753\n"}︡{"done":true}︡
︠09eb49f2-9a6d-488f-9350-77c294c8543csi︠
t
︡66f1c508-90c3-45c8-8634-3e8a3de9b175︡{"done":true}︡
︠6de2a4f0-0f46-4f7e-be54-0f0e0cd1d45ds︠
for k in srange(10,90,10):
    factor_time(k)
︡2a547793-0482-429e-8386-1d8ddf98e419︡{"stdout":"8.05362701416e-05"}︡{"stdout":"\n0.000219452667236"}︡{"stdout":"\n0.00155693435669"}︡{"stdout":"\n0.00596276092529"}︡{"stdout":"\n0.0131066799164"}︡{"stdout":"\n0.0466529846191"}︡︡{"stdout":"\n0.213326597214"}︡{"stdout":"\n0.866991996765"}︡{"stdout":"\n"}︡{"done":true}
︠c9546056-0c84-43b6-a73d-e85b85b195ffs︠
map(lambda k:[k,factor_time(k)],srange(5,30,5))
︡89571d20-eb9a-4bf3-b168-cd122bb266b8︡{"stdout":"4.76112365723e-05"}︡{"stdout":"\n8.1022644043e-05"}︡{"stdout":"\n0.00013451385498"}︡{"stdout":"\n0.000207384109497"}︡{"stdout":"\n0.000469622421265"}︡{"stdout":"\n[[5, None], [10, None], [15, None], [20, None], [25, None]]\n"}︡{"done":true}︡
︠be95a6eb-49d0-42b4-91e7-004a11105031s︠
g=lambda k:[k,factor_time(k)]
︡215580f2-e51f-4d88-a676-bf9b459a55f6︡{"done":true}︡
︠04723924-1ff9-4abe-a3b7-8f01bc343cc8s︠
g(40)
︡4c767f42-7787-44b5-b54a-006c03f5f64f︡{"stdout":"0.00633575248718"}︡{"stdout":"\n[40, None]\n"}︡{"done":true}︡
︠8d1d2e5f-0b7c-4d71-b64a-a8efa8314caas︠
timeit?
︡c8506e4e-ed4c-43b5-b356-9767e9ca91ca︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\nSignature : timeit(*args, **kwds)\nDocstring :\nTime execution of a command or block of commands.\n\nThis command has been enhanced for Salvus so you may use it as a\nblock decorator as well, e.g.,\n\n   %timeit 2+3\n\nand\n\n   %timeit(number=10, preparse=False)  2^3\n\n   %timeit(number=10, seconds=True)  2^3\n\nand\n\n   %timeit(preparse=False)\n\n   [rest of the cell]\n\nHere is the original docstring for timeit:\n\nnodetex Accurately measure the wall time required to execute\n\"stmt\".\n\nINPUT:\n\n* \"stmt\" -- a text string.\n\n* \"globals_dict\" -- a dictionary or \"None\" (default). Evaluate\n  \"stmt\" in the context of the globals dictionary. If not set, the\n  current \"globals()\" dictionary is used.\n\n* \"preparse\" -- (default: use globals preparser default) if\n  \"True\" preparse \"stmt\" using the Sage preparser.\n\n* \"number\" -- integer, (optional, default: 0), number of loops.\n\n* \"repeat\" -- integer, (optional, default: 3), number of\n  repetition.\n\n* \"precision\" -- integer, (optional, default: 3), precision of\n  output time.\n\n* \"seconds\" -- boolean (default: \"False\"). Whether to just return\n  time in seconds.\n\nOUTPUT:\n\nAn instance of \"SageTimeitResult\" unless the optional parameter\n\"seconds=True\" is passed. In that case, the elapsed time in seconds\nis returned as a floating-point number.\n\nEXAMPLES:\n\n   sage: from sage.misc.sage_timeit import sage_timeit\n   sage: sage_timeit('3^100000', globals(), preparse=True, number=50)      # random output\n   '50 loops, best of 3: 1.97 ms per loop'\n   sage: sage_timeit('3^100000', globals(), preparse=False, number=50)     # random output\n   '50 loops, best of 3: 67.1 ns per loop'\n   sage: a = 10\n   sage: sage_timeit('a^2', globals(), number=50)                            # random output\n   '50 loops, best of 3: 4.26 us per loop'\n\nIf you only want to see the timing and not have access to\nadditional information, just use the \"timeit\" object:\n\n   sage: timeit('10^2', number=50)\n   50 loops, best of 3: ... per loop\n\nUsing sage_timeit gives you more information though:\n\n   sage: s = sage_timeit('10^2', globals(), repeat=1000)\n   sage: len(s.series)\n   1000\n   sage: mean(s.series)   # random output\n   3.1298141479492283e-07\n   sage: min(s.series)    # random output\n   2.9258728027343752e-07\n   sage: t = stats.TimeSeries(s.series)\n   sage: t.scale(10^6).plot_histogram(bins=20,figsize=[12,6], ymax=2)\n   Graphics object consisting of 20 graphics primitives\n\nThe input expression can contain newlines (but doctests cannot, so\nwe use \"os.linesep\" here):\n\n   sage: from sage.misc.sage_timeit import sage_timeit\n   sage: from os import linesep as CR\n   sage: # sage_timeit(r'a = 2nb=131nfactor(a^b-1)')\n   sage: sage_timeit('a = 2' + CR + 'b=131' + CR + 'factor(a^b-1)',\n   ....:             globals(), number=10)\n   10 loops, best of 3: ... per loop\n\nTest to make sure that \"timeit\" behaves well with output:\n\n   sage: timeit(\"print 'Hi'\", number=50)\n   50 loops, best of 3: ... per loop\n\nIf you want a machine-readable output, use the \"seconds=True\"\noption:\n\n   sage: timeit(\"print 'Hi'\", seconds=True)   # random output\n   1.42555236816e-06\n   sage: t = timeit(\"print 'Hi'\", seconds=True)\n   sage: t     #r random output\n   3.6010742187499999e-07"}}︡{"done":true}︡
︠a8d888b6-e54f-43a1-8157-3de1b5f53d99︠









